import { createSlice, PayloadAction } from '@reduxjs/toolkit'
import type { RootState } from '@ts/store'

// Define a type for the slice state
interface EmailState {
  value: string
}

// Define the initial state using that type
const initialState: EmailState = {
  value: "",
}

export const emailSlice = createSlice({
  name: 'email',
  // `createSlice` will infer the state type from the `initialState` argument
  initialState,
  reducers: {
    // Use the PayloadAction type to declare the contents of `action.payload`
    set: (state, action: PayloadAction<string>) => {
      state.value = action.payload
    },
  },
})

export const { set } = emailSlice.actions

// Other code such as selectors can use the imported `RootState` type
export const selectEmail = (state: RootState) => state.email.value

export default emailSlice.reducer
